C ______________________________	 Convert PM format to ASCII 
C		             November 1997         A. Klypin (aklypin@nmsu.edu) 
C		                     
C          Scales internal PM coordinates and velocities 
C          to  coordinates in Mpc/h and km/s
C          In PM the coordinates are in the range 1 - (NGRID+1)
C                     velocities are P = a_expansion*V_pec/(x_0H_0)
C                     where     x_0 = comoving cell_size=Box/Ngrid
C                                    H_0 = Hubble at z=0
C                   
C	     NROW = number of particles in 1D
C	     NGRID= number of cells        in 1D
       INCLUDE 'PMparameters.h'
       REAL     INPUT
       Character  FileASCII*50
C...................................................................
C			Read data and open files

      CALL RDTAPTWO

      WRITE (*,'(A,$)') 'Enter File Name for ASCII data = '
      READ  (*,'(A)') FileASCII
      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN')

      write (*,*) ' RDTAPE is done'
c      WRITE (17,100) HEADER,
c     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
c     +                  EKIN,
c     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
c     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
      Box  =INPUT(' Enter box size in comoving Mpc/h =')
      BoxV =Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
      ScaleC = Box/NGRID         ! scale factor for Coordinates

      xmax =-1.e+9
      xmin = 1.e+9
      vmax =-1.e+9
      vmin = 1.e+9
      Icount =0
c      DO ifile =1,Nspecies+1
      ifile=1
C				       Loop over particles
c       DO IROW=1,NROW
c                   write (*,*) ' Read page=',IROW,' file=',ifile
	      CALL GETROW(1,1)
	      DO IN=1,NPAGE
	        X  =ScaleC* (XPAR(IN)-1.)
	        Y  =ScaleC* (YPAR(IN)-1.)
	        Z  =ScaleC* (ZPAR(IN)-1.)
           Vxs=ScaleV* VX(IN)
           Vys=ScaleV* VY(IN)
           Vzs=ScaleV* VZ(IN)
           Icount =Icount +1
           xmax =MAX(xmax,X,Y,Z)
           xmin =MIN(xmin,X,Y,Z)
           vmax =MAX(vmax,Vxs,Vys,Vzs)
           vmin =MIN(vmin,Vxs,Vys,Vzs)
           write (17,200) X,Y,Z
 200       Format(3e20.12)
	      ENDDO
c        ENDDO 
c      ENDDO

      write (*,*) ' Scaled Coordinates were written to:',
     &            FileASCII
      write (*,*) ' Number of particles          =',Icount
      write (*,*) ' Min/Max of coordinates(Mpc/h)=',xmin,xmax
      write (*,*) ' Min/Max of velocities (km/s) =',vmin,vmax

      END


c--------------------------------------------------
C                                  Read  current data from disk/tape,
C                                  Open files
C                                  Nrecl is the number of values in a record
C                                  Npage is the number of particles in a page
      SUBROUTINE RDTAPTWO
C---------------------------------------------------
      INCLUDE 'PMparameters.h'
      Character  Hd*5,Tail*4,Nm*40

      Character  Filebin*50
C...................................................................
C			Read data and open files
      WRITE (*,'(A,$)') 'Enter File Name of Binary data = '
      READ  (*,'(A)') Filebin


      Hd  ='PMcrs'
      Tail='.DAT'
C                                     Open file on a tape
c      OPEN(UNIT=9,FILE=Filebin,
c     +                FORM='UNFORMATTED', STATUS='UNKNOWN')
C                                 Read control information
C                                 and see whether it has proper
C                                 structure
c      READ  (9,err=10,end=10) HEADER,
c     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
c     +                  TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
c     +                  NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5,
c     +                   Ocurv,extras(100)
c      WRITE (*,100) HEADER,
c     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
c     +                  EKIN,EKIN1,EKIN2,
c     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
c     +                  Ocurv
c      WRITE (16,100) HEADER,
c     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
c     +                  EKIN,EKIN1,EKIN2,
c     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
c     +                  Ocurv
c100   FORMAT(1X,'Header=>',A45,/
c     +           1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
c     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',3E12.3,/
c     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
c     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
c     +            1x,' Omega_curvature=',F7.3)
c      IF(NROW.NE.NROWC) THEN
c         WRITE (*,*)
c     +            ' NROW in PARAMETER and in TAPE-FILE are different'
c      ENDIF
c      IF(NGRID.NE.NGRIDC) THEN
c         WRITE (*,*)
c     +           ' NGRID in PARAMETER and in TAPE-FILE are different:'
c         write (*,*) ' Ngrid=',NGRID,' NgridC=',NGRIDC
c      ENDIF
C                                         Open work file on disk
 10   NBYTE = NPAGE*4
      NACCES= NBYTE
c      Nspecies = 0



c      DO ifile=0,Nspecies
c         Nm = Hd//Char(ifile+48)//Tail
c         iun=21+ifile
c         write (*,*) ' File>',ifile,' unit=',iun,' Name=',Nm
         OPEN(UNIT=21,FILE=Filebin,ACCESS='DIRECT',
     +	               STATUS='UNKNOWN',RECL=NACCES)
c      EndDo
 
c      REWIND 9
      RETURN
      END

      SUBROUTINE GETROW(IROW,Ifile)
C--------------------------------------------
      INCLUDE 'PMparameters.h'
      READ  (21,REC=1) XPAR
      READ  (21,REC=2) YPAR
      READ  (21,REC=3) ZPAR
      READ  (21,REC=4) VX  
      READ  (21,REC=5) VY  
      READ  (21,REC=6) VZ  
      RETURN
      RETURN
      END


C---------------------------------- Read in variables      
      REAL FUNCTION INPUT(text)
C------------------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End
