#!/bin/bash

usage(){
	echo "Usage: $0 {-f filename} {-d dirname}"
	exit 1
}

createTree(){
    names=( "AlphaHalf" "AlphaZero" )
    vals=(500 1000 3000 )
    sizes=(64 128 256 400)
    
    path="/work/markwy/Fresh/"
    
    for ((i=0; i<=1; i++))
    do
	./direc.sh -d ${names[$i]}
	cp direc.sh ${names[$i]}
	cp linerep.py ${names[$i]}
	cd ${names[$i]}
	for((k=0;k<=2;k++))
	do
	    ./direc.sh -d rc${vals[$k]}
	    cp direc.sh rc${vals[$k]}
            cp linerep.py rc${vals[$k]}
	    cd rc${vals[$k]}
	    for ((j=0; j<=3; j++))
	    do
		./direc.sh -d ${sizes[$j]}Mpc
		cp $path*.f ./${sizes[$j]}Mpc/
		cp $path*.txt ./${sizes[$j]}Mpc/
		cp $path*.fit ./${sizes[$j]}Mpc/
		cp $path*.h ./${sizes[$j]}Mpc/
		cp $path* ./${sizes[$j]}Mpc/
		cp linerep.py ./${sizes[$j]}Mpc/ 
		cd ${sizes[$j]}Mpc
		python linerep.py cosmoparams.txt 5 ${sizes[$j]} 0 > newparams.txt
		cp newparams.txt cosmoparams.txt
		rm newparams.txt
		name="RC="${vals[$k]}
#		echo $name
		python linerep.py PMrun.f 26 $name.0 6 > PMgun.f
		cp PMgun.f PMrun.f
		rm PMgun.f
		cd ../
	    done
	    cd ../
	done
	cd ../
    done
}

copyFile(){
    names=( "AlphaHalf" "AlphaZero" )
    vals=( 500 1000 3000 )
    sizes=(64 128 256 400)
    
    
    for ((i=0; i<=1; i++))
    do
	for((k=0;k<=2;k++))
	do
	    for ((j=0; j<=3; j++))
	    do
		cp ./$1 ./${names[$i]}/rc${vals[$k]}/${sizes[$j]}Mpc/
	    done
	done
    done
}

seedset(){
    names=( "AlphaHalf" "AlphaZero" )
    vals=( 500 1000 3000 )
    sizes=(64 128 256 400)
    
    
    for ((i=0; i<=1; i++))
    do
	for((k=0;k<=2;k++))
	do
	    for ((j=0; j<=3; j++))
	    do
		cd ${names[$i]}/rc${vals[$k]}/${sizes[$j]}Mpc/
		python linerep.py cosmoparams.txt 8 $1 0 > newparams.txt
		cp newparams.txt cosmoparams.txt
		rm newparams.txt
		cd ../../../
	    done
	done
    done
}

runset(){
    names=( "AlphaHalf" "AlphaZero" )
    vals=( 500 1000 3000 )
    sizes=(64 128 256 400)
    
    
	for((k=0;k<=2;k++))
	do
	    for ((j=0; j<=3; j++))
	    do
		cd ${names[$1]}/rc${vals[$k]}/${sizes[$j]}Mpc/
		./go.sh
     		cd ../../../
	    done
	done
}

while getopts t:c:s:r:v option
do
    case "${option}"
        in
        t) createTree ;;
        c) copyFile ${OPTARG};;
	s) seedset ${OPTARG};;
	r) runset ${OPTARG};;
        \?) usage
            exit 1;;
    esac
done
