#!/bin/bash

usage(){
	echo "Usage: $0 {-t null} {-c filename} {-s seednumber} {-r setnumber} {-f null}"
	exit 1
}

createTree(){
    names=( "1Set" "2Set" )
    vals=(1089 1665)
    sizes=(64 128 256 400)
    dim=(5)
   
    
	 nn=${#names[@]}
	 nv=${#vals[@]}
    ns=${#sizes[@]}
	 path="/lustre/markwy/Fresh/"
    
    for ((i=0; i<=nn-1; i++))
    do
	./direc.sh -d ${names[$i]}
	cp direc.sh ${names[$i]}
	cp linerep.py ${names[$i]}
	cd ${names[$i]}
	for((k=0;k<=nv-1;k++))
	do
	    ./direc.sh -d rc${vals[$k]}
	    cp direc.sh rc${vals[$k]}
            cp linerep.py rc${vals[$k]}
	    cd rc${vals[$k]}
	    for((j=0;j<=ns-1;j++))
	    do
		./direc.sh -d ${sizes[$j]}Mpc
		cp $path*.f ./${sizes[$j]}Mpc/
		cp $path*.txt ./${sizes[$j]}Mpc/
		cp $path*.fit ./${sizes[$j]}Mpc/
		cp $path*.h ./${sizes[$j]}Mpc/
		cp $path* ./${sizes[$j]}Mpc/
		cp $path*.pbs ./${sizes[$j]}Mpc/
		cp linerep.py ./${sizes[$j]}Mpc/ 
		cd ${sizes[$j]}Mpc
		python linerep.py cosmoparams.txt 5 ${sizes[0]} 0 > newparams.txt
		cp newparams.txt cosmoparams.txt
		rm newparams.txt
		name="RC="${vals[$k]}
#		echo $name
		python linerep.py PMrun.f 26 $name.0 6 > PMgun.f
		cp PMgun.f PMrun.f
		rm PMgun.f
		val="D="${dim[0]}
		python linerep.py PMrun.f 28 $val.0 6 > PMgun.f
		cp PMgun.f PMrun.f
		rm PMgun.f
		python linerep.py PMcomplete.f 19 $name.0 6 > PMgun.f
		cp PMgun.f PMcomplete.f
		rm PMgun.f
		python linerep.py PMcomplete.f 21 $val.0 6 > PMgun.f
		cp PMgun PMcomplete.f
		rm PMgun.f		
		cd ../
	    done
	    cd ../
	done
	cd ../
    done
}

copyFile(){
    names=( "1Set" "2Set" )
    vals=(1089 1665)
    sizes=(64 128 256 400)
    	 nn=${#names[@]}
	 nv=${#vals[@]}
    ns=${#sizes[@]}
	 
    for ((i=0; i<=nn-1; i++))
    do
	for((k=0;k<=nv-1;k++))
	do
	   for((j=0;j<=ns-1;j++))
	   do
		cp ./$1 ./${names[$i]}/rc${vals[$k]}/${sizes[$j]}Mpc/
	   done
	done
    done
}

seedset(){
    names=( "1Set" "2Set" )
    vals=(1089 1665)
    sizes=(64 128 256 400)
	 nn=${#names[@]}
	 nv=${#vals[@]}
    ns=${#sizes[@]}    
    
    for ((i=0; i<=nn-1; i++))
    do
	ran=`echo $1+$i*100 | bc`
	for((k=0;k<=nv-1;k++))
	do
	  for((j=0;j<=ns-1;j++))
		do
		cd ${names[$i]}/rc${vals[$k]}/${sizes[$j]}Mpc/
		python linerep.py cosmoparams.txt 8 $ran 0 > newparams.txt
		cp newparams.txt cosmoparams.txt
		rm newparams.txt
		cd ../../../
		done
	done
    done
}

runset(){
    names=( "1Set" "2Set")
    vals=(1089 1665)
    sizes=(64 128 256 400)
	 nn=${#names[@]}
	 nv=${#vals[@]}
    ns=${#sizes[@]}    
    
	for((k=0;k<=nn-1;k++))
	do
	    for ((j=0; j<=nv-1; j++))
	    do
		 for ((i=0; i<=ns-1;i++))
			do
		cd ${names[$k]}/rc${vals[$j]}/${sizes[$i]}Mpc/
		make
		msub mwfnal.pbs
     		cd ../../../
			done
	    done
	done
}

compset(){
    names=( "1Set" "2Set")
    vals=(1089 1665)
    sizes=(64 128 256 400)
	 nn=${#names[@]}
	 nv=${#vals[@]}
    ns=${#sizes[@]}    
    
	for((k=0;k<=nn-1;k++))
	do
	    for ((j=0; j<=nv-1; j++))
	    do
		 for ((i=0; i<=ns-1;i++))
			do
		cd ${names[$k]}/rc${vals[$j]}/${sizes[$i]}Mpc/
		make
		msub complete.pbs
     		cd ../../../
			done
	    done
	done
}


while getopts t:c:s:r:v option
do
    case "${option}"
        in
        t) createTree ;;
        c) copyFile ${OPTARG};;
	s) seedset ${OPTARG};;
	r) runset ${OPTARG};;
	f) compset ;;
        \?) usage
            exit 1;;
    esac
done
