c$$$      Has all non-specific-to-pi-physics
c$$$      subroutines. Just a collection of standard
c$$$      Numerical Recipes. Now, in 3d!


      SUBROUTINE line(i,j,k,n,nout)
      integer i,j,k,n,nout
      nout=n**2*(i-1)+n*(j-1)+k
      return
      end
      
      SUBROUTINE printrad(u,n,grid,Hd)
      integer n,half,k,grid
      double precision u(n,n,n)
      character Hd*3, Tail*4,mid*1,Nam*8
      
      half=n/2

c      Hd = 'RAD'
      Tail = '.txt'
      mid = Char(grid+48)
      Nam = Hd//mid//Tail

      Open(UNIT=33,File=Nam)

      do k=1,n
         write(33,*) k,u(half,half,k),u(half,k,half),u(k,half,half)
      end do

      close(33)
      return
      end



c      SUBROUTINE line2(i,j,k,n)
c      integer i,j,k,n,nout
c      line2=n**2*(i-1)+n*(j-1)+k
c      return
c      end


      DOUBLE PRECISION FUNCTION anorm2(a,n)
      INTEGER n
      DOUBLE PRECISION a(n,n,n)
      INTEGER i,j,k,nn
      DOUBLE PRECISION sum
      sum=0.d0
      do 13 k=1,n
        do 12 j=1,n
          do 11 i=1,n
c             call line(i,j,k,n,nn)
          sum=sum+a(i,j,k)**2
11        continue
12      continue
13    continue
      anorm2=sqrt(sum)/n**1.5
      return
      END

      DOUBLE PRECISION FUNCTION rms(a,n)
      INTEGER n
      DOUBLE PRECISION a(n,n,n)
      INTEGER i,j,k,nn
      DOUBLE PRECISION sum
      sum=0.d0
      do 13 k=1,n
        do 12 j=1,n
          do 11 i=1,n
c          nn= line2(i,j,k,n)
          sum=sum+a(i,j,k)**2
11        continue
12      continue
13    continue
      rms=sqrt(sum/n**3)
      return
      END

      SUBROUTINE copy(aout,ain,n)
      INTEGER n
      DOUBLE PRECISION aout(n,n,n),ain(n,n,n)
      INTEGER i,j,k,nn
      do 12 i=1,n
        do 11 j=1,n
          do 10 k=1,n
c          call line(i,j,k,n,nn)
          aout(i,j,k)=ain(i,j,k)
10        continue 
11      continue
12    continue
      return
      END

      SUBROUTINE interp(uf,uc,nf)
c$$$ 
      INTEGER nf
      DOUBLE PRECISION uc(nf/2,nf/2,nf/2),uf(nf,nf,nf)
      INTEGER ic,fi,jc,jf,nc,kc,kf,nnc,nnf,npx,npy,npz
      INTEGER fpx,fpy,fpz
      nc=nf/2
      do 13 kc=1,nc
        kf = 2*kc
        do 12 jc=1,nc
          jf=2*jc
          do 11 ic=1,nc

          fi = ic*2

             npx=mod(ic,nc)+1
             npy=mod(jc,nc)+1
             npz=mod(kc,nc)+1

             fpx=mod(fi,nf)+1
             fpy=mod(jf,nf)+1
             fpz=mod(kf,nf)+1
             
          uf(fi,jf,kf)=uc(ic,jc,kc)

          uf(fpx,jf,kf)=.5d0*(uc(ic,jc,kc)+uc(npx,jc,kc))
          uf(fi,fpy,kf)=.5d0*(uc(ic,jc,kc)+uc(ic,npy,kc))
          uf(fi,jf,fpz)=.5d0*(uc(ic,jc,kc)+uc(ic,jc,npz))

          uf(fpx,fpy,kf) = 0.25d0*(uc(ic,jc,kc)+uc(npx,jc,kc)+
     &             uc(ic,npy,kc)+uc(npx,npy,kc))

          uf(fi,fpy,fpz) = 0.25d0*(uc(ic,jc,kc)+uc(ic,jc,npz)+
     &             uc(ic,npy,kc)+uc(ic,npy,npz))

          uf(fpx,jf,fpz) = 0.25d0*(uc(ic,jc,kc)+uc(npx,jc,kc)+
     &             uc(ic,jc,npz)+uc(npx,jc,npz))    

          uf(fpx,fpy,fpz) = 0.125d0*(uc(ic,jc,kc)+uc(npx,jc,kc)+
     &    uc(ic,npy,kc)+uc(ic,jc,npz)+uc(npx,jc,npz))+
     &  0.125d0*(uc(npx,npy,kc)+uc(ic,npy,npz)+uc(npx,npy,npz))     
      
          
11      continue
12    continue
13    continue


      return
      END


      SUBROUTINE smooth(usm,ush,nf)
      INTEGER nf
      DOUBLE PRECISION ush(nf,nf,nf),usm(nf,nf,nf)
      INTEGER kc, kf, ic,fi,jc,jf,f
      INTEGER npx,npy,npz,nmx,nmy,nmz
   
      do 13 kf=1,nf
        
        do 12 jf=1,nf
         
          do 11 fi=1,nf
            

             npx=mod(fi,nf)+1
             npy=mod(jf,nf)+1
             npz=mod(kf,nf)+1
             nmx=mod(fi+nf-2,nf)+1
             nmy=mod(jf+nf-2,nf)+1
             nmz=mod(kf+nf-2,nf)+1

            usm(fi,jf,kf)=.191d0*ush(fi,jf,kf)+
     &.0703d0*(ush(npx,jf,kf)+ush(nmx,jf,kf)+ush(fi,npy,kf))+
     &.0703d0*(ush(fi,nmy,kf)+ush(fi,jf,npz)+ush(fi,jf,nmz))+
     &.0259d0*(ush(npx,npy,kf)+ush(nmx,npy,kf)+ush(npx,nmy,kf))+
     &.0259d0*(ush(nmx,nmy,kf)+ush(fi,npy,npz)+ush(fi,nmy,npz))+
     &.0259d0*(ush(fi,npy,nmz)+ush(fi,nmy,nmz)+ush(npx,jf,npz))+
     &.0259d0*(ush(nmx,jf,npz)+ush(npx,jf,nmz)+ush(nmx,jf,nmz))+
     &.0095d0*(ush(npx,npy,npz)+ush(npx,npy,nmz)+ush(npx,nmy,npz))+
     &.0095d0*(ush(npx,nmy,nmz)+ush(nmx,npy,npz)+ush(nmx,npy,nmz))+
     &.0095d0*(ush(nmx,nmy,npz)+ush(nmx,nmy,nmz))

c            if(uc(ic,jc,kc)>5) then 
c        write(*,*) ic,jc,kc,nc," trouble ",uc(ic,jc,kc),uf(fi,jf,kf)
c        write(*,*) npx,npy,npz,nmx,nmy,nmz
c            pause
c            endif
            

c     *.0208333333d0*(uf(npx,npy,kf)+uf(npx,nmy,kf)+uf(nmx,npy,kf))+
c     *.0208333333d0*(uf(nmx,nmy,kf)+uf(npx,jf,npz)+uf(npx,jf,nmz))+
c     *.0208333333d0*(uf(nmx,jf,npz)+uf(nmx,jf,nmz)+uf(fi,npy,npz))+
c     *.0208333333d0*(uf(fi,nmy,npz)+uf(fi,npy,nmz)+uf(fi,nmy,nmz))
c            if(nc==4)then
c               write(*,*) uc(ic,jc,kc), 0.5*uf(fi,jf,kf), " stric"
c               write(*,*) npx,npy,npz,nmx,nmy,nmz
c               endif
11        continue
12      continue
13    continue  

      
c
c     this is restriction presuming Dirichelet BCs
c
c$$$      do 15 ic=1,nc
c$$$      do 14 jc=1,nc
c$$$        uc(1,ic,jc)=uf(1,2*ic-1,2*jc-1)
c$$$        uc(ic,1,jc)=uf(2*ic-1,1,2*jc-1)
c$$$        uc(ic,jc,1)=uf(2*ic-1,2*jc-1,1)
c$$$        uc(nc,ic,jc)=uf(2*nc-1,2*ic-1,2*jc-1)
c$$$        uc(ic,nc,jc)=uf(2*ic-1,2*nc-1,2*jc-1)
c$$$        uc(ic,jc,nc)=uf(2*ic-1,2*jc-1,2*nc-1)
c$$$14     continue
c$$$15     continue

      return
      END
		
				      
		SUBROUTINE smoother(usm,ush,nf)
      INTEGER nf
      DOUBLE PRECISION ush(nf,nf,nf),usm(nf,nf,nf)
      INTEGER kc, kf, ic,fi,jc,jf,f
      INTEGER npx,npy,npz,nmx,nmy,nmz
   
      do 13 kf=1,nf
        
        do 12 jf=1,nf
         
          do 11 fi=1,nf
            

             npx=mod(fi,nf)+1
             npy=mod(jf,nf)+1
             npz=mod(kf,nf)+1
             nmx=mod(fi+nf-2,nf)+1
             nmy=mod(jf+nf-2,nf)+1
             nmz=mod(kf+nf-2,nf)+1

            usm(fi,jf,kf)=.0924d0*ush(fi,jf,kf)+
     &.056d0*(ush(npx,jf,kf)+ush(nmx,jf,kf)+ush(fi,npy,kf))+
     &.056d0*(ush(fi,nmy,kf)+ush(fi,jf,npz)+ush(fi,jf,nmz))+
     &.0339d0*(ush(npx,npy,kf)+ush(nmx,npy,kf)+ush(npx,nmy,kf))+
     &.0339d0*(ush(nmx,nmy,kf)+ush(fi,npy,npz)+ush(fi,nmy,npz))+
     &.0339d0*(ush(fi,npy,nmz)+ush(fi,nmy,nmz)+ush(npx,jf,npz))+
     &.0339d0*(ush(nmx,jf,npz)+ush(npx,jf,nmz)+ush(nmx,jf,nmz))+
     &.0206d0*(ush(npx,npy,npz)+ush(npx,npy,nmz)+ush(npx,nmy,npz))+
     &.0206d0*(ush(npx,nmy,nmz)+ush(nmx,npy,npz)+ush(nmx,npy,nmz))+
     &.0206d0*(ush(nmx,nmy,npz)+ush(nmx,nmy,nmz))

11        continue
12      continue
13    continue  


      return
      END
	

		

      SUBROUTINE matadd(a,b,c,n)
      INTEGER n
      DOUBLE PRECISION a(n,n,n),b(n,n,n),c(n,n,n)
      INTEGER i,j,k
      do 13 k=1,n
        do 12 j=1,n
          do 11 i=1,n
            c(i,j,k)=a(i,j,k)+b(i,j,k)
11        continue
12      continue
13    continue
      return
      END

      SUBROUTINE veccop(a,b,n)
c  copies a into b
      INTEGER n
      DOUBLE PRECISION a(n),b(n)
      INTEGER i
      do i=1,n
         b(i)=a(i)
      end do
      return
      END
		
      SUBROUTINE matsub(a,b,c,n)
      INTEGER n
      DOUBLE PRECISION a(n,n,n),b(n,n,n),c(n,n,n)
      INTEGER i,j,k
      do 13 k=1,n
        do 12 j=1,n
          do 11 i=1,n
            c(i,j,k)=a(i,j,k)-b(i,j,k)
11        continue
12      continue
13    continue
      return
      END

      SUBROUTINE rstrct(uc,uf,nc)
      INTEGER nc
      DOUBLE PRECISION uc(nc,nc,nc),uf(2*nc,2*nc,2*nc)
      INTEGER kc, kf, ic,fi,jc,jf,f, nf
      INTEGER npx,npy,npz,nmx,nmy,nmz
      nf=2*nc
      do 13 kc=1,nc
        kf = 2*kc
        do 12 jc=1,nc
          jf=2*jc
          do 11 ic=1,nc
            fi=2*ic

             npx=mod(fi,nf)+1
             npy=mod(jf,nf)+1
             npz=mod(kf,nf)+1
             nmx=mod(fi+nf-2,nf)+1
             nmy=mod(jf+nf-2,nf)+1
             nmz=mod(kf+nf-2,nf)+1

            uc(ic,jc,kc)=.125d0*uf(fi,jf,kf)+
     &.0625d0*(uf(npx,jf,kf)+uf(nmx,jf,kf)+uf(fi,npy,kf))+
     &.0625d0*(uf(fi,nmy,kf)+uf(fi,jf,npz)+uf(fi,jf,nmz))+
     &.03125d0*(uf(npx,npy,kf)+uf(nmx,npy,kf)+uf(npx,nmy,kf))+
     &.03125d0*(uf(nmx,nmy,kf)+uf(fi,npy,npz)+uf(fi,nmy,npz))+
     &.03125d0*(uf(fi,npy,nmz)+uf(fi,nmy,nmz)+uf(npx,jf,npz))+
     &.03125d0*(uf(nmx,jf,npz)+uf(npx,jf,nmz)+uf(nmx,jf,nmz))+
     &.015625d0*(uf(npx,npy,npz)+uf(npx,npy,nmz)+uf(npx,nmy,npz))+
     &.015625d0*(uf(npx,nmy,nmz)+uf(nmx,npy,npz)+uf(nmx,npy,nmz))+
     &.015625d0*(uf(nmx,nmy,npz)+uf(nmx,nmy,nmz))

c            if(uc(ic,jc,kc)>5) then 
c        write(*,*) ic,jc,kc,nc," trouble ",uc(ic,jc,kc),uf(fi,jf,kf)
c        write(*,*) npx,npy,npz,nmx,nmy,nmz
c            pause
c            endif
            

c     *.0208333333d0*(uf(npx,npy,kf)+uf(npx,nmy,kf)+uf(nmx,npy,kf))+
c     *.0208333333d0*(uf(nmx,nmy,kf)+uf(npx,jf,npz)+uf(npx,jf,nmz))+
c     *.0208333333d0*(uf(nmx,jf,npz)+uf(nmx,jf,nmz)+uf(fi,npy,npz))+
c     *.0208333333d0*(uf(fi,nmy,npz)+uf(fi,npy,nmz)+uf(fi,nmy,nmz))
c            if(nc==4)then
c               write(*,*) uc(ic,jc,kc), 0.5*uf(fi,jf,kf), " stric"
c               write(*,*) npx,npy,npz,nmx,nmy,nmz
c               endif
11        continue
12      continue
13    continue  

      
c
c     this is restriction presuming Dirichelet BCs
c
c$$$      do 15 ic=1,nc
c$$$      do 14 jc=1,nc
c$$$        uc(1,ic,jc)=uf(1,2*ic-1,2*jc-1)
c$$$        uc(ic,1,jc)=uf(2*ic-1,1,2*jc-1)
c$$$        uc(ic,jc,1)=uf(2*ic-1,2*jc-1,1)
c$$$        uc(nc,ic,jc)=uf(2*nc-1,2*ic-1,2*jc-1)
c$$$        uc(ic,nc,jc)=uf(2*ic-1,2*nc-1,2*jc-1)
c$$$        uc(ic,jc,nc)=uf(2*ic-1,2*jc-1,2*nc-1)
c$$$14     continue
c$$$15     continue

      return
      END

      SUBROUTINE matscalmult(u,scal,n)
      INTEGER n
      DOUBLE PRECISION u(n,n,n),scal
      INTEGER i,j,k
      do 13 k=1,n
        do 12 j=1,n
          do 11 i=1,n
            u(i,j,k)=scal*u(i,j,k)
11        continue
12      continue
13    continue  
      return
      END



      SUBROUTINE fill0(u,n)
      INTEGER n
      DOUBLE PRECISION u(n,n,n)
      INTEGER i,j,k
      do 13 k=1,n
        do 12 j=1,n
          do 11 i=1,n
            u(i,j,k)=0.d0
11        continue
12      continue
13    continue  
      return
      END

      SUBROUTINE fill02d(u,n)
      INTEGER n
      DOUBLE PRECISION u(n,n)
      INTEGER i,j,k
        do 12 j=1,n
          do 11 i=1,n
            u(i,j)=0.d0
11        continue
12      continue
      return
      END

      SUBROUTINE ludcmp(a,n,np,indx,d)
      INTEGER n,np,indx(n),NMAX
      double precision d,a(np,np),TINY
      PARAMETER (TINY=1.0e-22)
      INTEGER i,imax,j,k
      double precision aamax,dum,sum,vv(n)
      d=1.
c        write(*,*) aamax, "in ludcmp"

      do 12 i=1,n
        aamax=0.
        do 11 j=1,n
          if (abs(a(i,j)).gt.aamax) aamax=abs(a(i,j))
11      continue
c        if (aamax.eq.0.) write(*,*) i,j,aamax,a(i,j)
        if (aamax.eq.0.) pause 'singular matrix in ludcmp'
        vv(i)=1./aamax
12    continue
      do 19 j=1,n
        do 14 i=1,j-1
          sum=a(i,j)
          do 13 k=1,i-1
            sum=sum-a(i,k)*a(k,j)
13        continue
          a(i,j)=sum
14      continue
        aamax=0.
        do 16 i=j,n
          sum=a(i,j)
          do 15 k=1,j-1
            sum=sum-a(i,k)*a(k,j)
15        continue
          a(i,j)=sum
          dum=vv(i)*abs(sum)
          if (dum.ge.aamax) then
            imax=i
            aamax=dum
          endif
16      continue
        if (j.ne.imax)then
          do 17 k=1,n
            dum=a(imax,k)
            a(imax,k)=a(j,k)
            a(j,k)=dum
17        continue
          d=-d
          vv(imax)=vv(j)
        endif
        indx(j)=imax
        if(a(j,j).eq.0.)a(j,j)=TINY
        if(j.ne.n)then
          dum=1./a(j,j)
          do 18 i=j+1,n
            a(i,j)=a(i,j)*dum
18        continue
        endif
19    continue
      return
      END

      SUBROUTINE lubksb(a,n,np,indx,b)
      INTEGER n,np,indx(n)
      DOUBLE PRECISION a(np,np),b(np),sum
      INTEGER i,ii,j,ll
      ii=0
      sum=0.0

      do 12 i=1,n
        ll=indx(i)
        sum=b(ll)
        b(ll)=b(i)
        if (ii.ne.0)then
          do 11 j=ii,i-1
            sum=sum-a(i,j)*b(j)
11        continue
        else if (sum.ne.0.) then
          ii=i
        endif
        b(i)=sum
12    continue


      do 14 i=n,1,-1
        sum=b(i)
        do 13 j=i+1,n
          sum=sum-a(i,j)*b(j)
13      continue
        if(a(i,i)==0) pause 'infinity in backsub'
        b(i)=sum/a(i,i)
14    continue
      return
      END


      SUBROUTINE avetozero(a,n)
      integer n,i,j,k,n3
      double precision a(n,n,n),asum
      n3 = n**3
      asum=0

      do 12 i=1,n
         do 11 j=1,n
            do 10 k=1,n
             asum=asum+a(i,j,k)
 10          continue
 11          continue
 12          continue

           do 15 i=1,n
              do 14 j=1,n
                 do 13 k=1,n
               a(i,j,k)=a(i,j,k)-asum/(1.d0*n3)
 13          continue
 14          continue
 15          continue

       return 
       end
      
      SUBROUTINE cornertozero(a,n)
      integer n,i,j,k,n3
      double precision a(n,n,n),asum
      n3 = n**3


           do 15 i=1,n
              do 14 j=1,n
                 do 13 k=1,n
               a(i,j,k)=a(i,j,k)-a(1,1,1)
 13          continue
 14          continue
 15          continue

       return 
       end

      FUNCTION ran1(idum)
      INTEGER idum,IA,IM,IQ,IR,NTAB,NDIV
      DOUBLE PRECISION ran1,AM,EPS,RNMX
      PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     *NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
      INTEGER j,k,iv(NTAB),iy
      SAVE iv,iy
      DATA iv /NTAB*0/, iy /0/
      if (idum.le.0.or.iy.eq.0) then
        idum=max(-idum,1)
        do 11 j=NTAB+8,1,-1
          k=idum/IQ
          idum=IA*(idum-k*IQ)-IR*k
          if (idum.lt.0) idum=idum+IM
          if (j.le.NTAB) iv(j)=idum
11      continue
        iy=iv(1)
      endif
      k=idum/IQ
      idum=IA*(idum-k*IQ)-IR*k
      if (idum.lt.0) idum=idum+IM
      j=1+iy/NDIV
      iy=iv(j)
      iv(j)=idum
      ran1=min(AM*iy,RNMX)
      return
      END
		      
		FUNCTION maloc(len)
      include 'PMparameters.h'
C So far working for 3d; but only lightly changed from 2d
      INTEGER maloc,len,NG,MEMLEN
C      PARAMETER (NG=7,MEMLEN=13*2**(2*NG)/3+14*2**NG+8*NG-100/3)
      PARAMETER (MEMLEN=17*2**(3*NG)/3+14*2**NG+8*NG)
c      PARAMETER (NG=8,MEMLEN=17*2**(3*NG)/3+14*2**NG+8*NG)
      INTEGER mem
      DOUBLE PRECISION z
      COMMON /memory/ z(MEMLEN),mem
      if (mem+len+1.gt.MEMLEN) then
c         write(*,*)'insufficient memory in maloc'
         pause
      endif
      z(mem+1)=len
      maloc=mem+2
      mem=mem+len+1
      return
      END
